Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 956)
+++ lemon/concepts/graph_components.h	(revision 313)
@@ -607,59 +583,68 @@
       typedef IterableDigraphComponent Digraph;
 
-      /// \name Base Iteration
-      ///
-      /// This interface provides functions for iteration on digraph items.
+      /// \name Base iteration
+      ///
+      /// This interface provides functions for iteration on digraph items
       ///
       /// @{
 
-      /// \brief Return the first node.
-      ///
-      /// This function gives back the first node in the iteration order.
+      /// \brief Gives back the first node in the iterating order.
+      ///
+      /// Gives back the first node in the iterating order.
+      ///
       void first(Node&) const {}
 
-      /// \brief Return the next node.
-      ///
-      /// This function gives back the next node in the iteration order.
+      /// \brief Gives back the next node in the iterating order.
+      ///
+      /// Gives back the next node in the iterating order.
+      ///
       void next(Node&) const {}
 
-      /// \brief Return the first arc.
-      ///
-      /// This function gives back the first arc in the iteration order.
+      /// \brief Gives back the first arc in the iterating order.
+      ///
+      /// Gives back the first arc in the iterating order.
+      ///
       void first(Arc&) const {}
 
-      /// \brief Return the next arc.
-      ///
-      /// This function gives back the next arc in the iteration order.
+      /// \brief Gives back the next arc in the iterating order.
+      ///
+      /// Gives back the next arc in the iterating order.
+      ///
       void next(Arc&) const {}
 
-      /// \brief Return the first arc incomming to the given node.
-      ///
-      /// This function gives back the first arc incomming to the
+
+      /// \brief Gives back the first of the arcs point to the given
+      /// node.
+      ///
+      /// Gives back the first of the arcs point to the given node.
+      ///
+      void firstIn(Arc&, const Node&) const {}
+
+      /// \brief Gives back the next of the arcs points to the given
+      /// node.
+      ///
+      /// Gives back the next of the arcs points to the given node.
+      ///
+      void nextIn(Arc&) const {}
+
+      /// \brief Gives back the first of the arcs start from the
       /// given node.
-      void firstIn(Arc&, const Node&) const {}
-
-      /// \brief Return the next arc incomming to the given node.
-      ///
-      /// This function gives back the next arc incomming to the
-      /// given node.
-      void nextIn(Arc&) const {}
-
-      /// \brief Return the first arc outgoing form the given node.
-      ///
-      /// This function gives back the first arc outgoing form the
-      /// given node.
+      ///
+      /// Gives back the first of the arcs start from the given node.
+      ///
       void firstOut(Arc&, const Node&) const {}
 
-      /// \brief Return the next arc outgoing form the given node.
-      ///
-      /// This function gives back the next arc outgoing form the
-      /// given node.
+      /// \brief Gives back the next of the arcs start from the given
+      /// node.
+      ///
+      /// Gives back the next of the arcs start from the given node.
+      ///
       void nextOut(Arc&) const {}
 
       /// @}
 
-      /// \name Class Based Iteration
-      ///
-      /// This interface provides iterator classes for digraph items.
+      /// \name Class based iteration
+      ///
+      /// This interface provides functions for iteration on digraph items
       ///
       /// @{
@@ -671,7 +656,7 @@
       typedef GraphItemIt<Digraph, Node> NodeIt;
 
-      /// \brief This iterator goes through each arc.
-      ///
-      /// This iterator goes through each arc.
+      /// \brief This iterator goes through each node.
+      ///
+      /// This iterator goes through each node.
       ///
       typedef GraphItemIt<Digraph, Arc> ArcIt;
@@ -679,5 +664,5 @@
       /// \brief This iterator goes trough the incoming arcs of a node.
       ///
-      /// This iterator goes trough the \e incoming arcs of a certain node
+      /// This iterator goes trough the \e inccoming arcs of a certain node
       /// of a digraph.
       typedef GraphIncIt<Digraph, Arc, Node, 'i'> InArcIt;
@@ -691,24 +676,24 @@
       /// \brief The base node of the iterator.
       ///
-      /// This function gives back the base node of the iterator.
-      /// It is always the target node of the pointed arc.
+      /// Gives back the base node of the iterator.
+      /// It is always the target of the pointed arc.
       Node baseNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// This function gives back the running node of the iterator.
-      /// It is always the source node of the pointed arc.
+      /// Gives back the running node of the iterator.
+      /// It is always the source of the pointed arc.
       Node runningNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The base node of the iterator.
       ///
-      /// This function gives back the base node of the iterator.
-      /// It is always the source node of the pointed arc.
+      /// Gives back the base node of the iterator.
+      /// It is always the source of the pointed arc.
       Node baseNode(const OutArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// This function gives back the running node of the iterator.
-      /// It is always the target node of the pointed arc.
+      /// Gives back the running node of the iterator.
+      /// It is always the target of the pointed arc.
       Node runningNode(const OutArcIt&) const { return INVALID; }
 
@@ -752,10 +737,10 @@
 
             typename _Digraph::Node n;
-            const typename _Digraph::InArcIt iait(INVALID);
-            const typename _Digraph::OutArcIt oait(INVALID);
-            n = digraph.baseNode(iait);
-            n = digraph.runningNode(iait);
-            n = digraph.baseNode(oait);
-            n = digraph.runningNode(oait);
+            typename _Digraph::InArcIt ieit(INVALID);
+            typename _Digraph::OutArcIt oeit(INVALID);
+            n = digraph.baseNode(ieit);
+            n = digraph.runningNode(ieit);
+            n = digraph.baseNode(oeit);
+            n = digraph.runningNode(oeit);
             ignore_unused_variable_warning(n);
           }
@@ -763,18 +748,18 @@
 
         const _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for iterable undirected graphs.
-    ///
-    /// This class describes the interface of iterable undirected
-    /// graphs. It extends \ref IterableDigraphComponent with the core
-    /// iterable interface of undirected graphs.
+
+      };
+    };
+
+    /// \brief An empty iterable undirected graph class.
+    ///
+    /// This class provides beside the core graph features iterator
+    /// based iterable interface for the undirected graph structure.
     /// This concept is part of the Graph concept.
-    template <typename BAS = BaseGraphComponent>
-    class IterableGraphComponent : public IterableDigraphComponent<BAS> {
-    public:
-
-      typedef BAS Base;
+    template <typename _Base = BaseGraphComponent>
+    class IterableGraphComponent : public IterableDigraphComponent<_Base> {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -784,29 +769,34 @@
       typedef IterableGraphComponent Graph;
 
-      /// \name Base Iteration
-      ///
-      /// This interface provides functions for iteration on edges.
-      ///
+      /// \name Base iteration
+      ///
+      /// This interface provides functions for iteration on graph items
       /// @{
 
-      using IterableDigraphComponent<Base>::first;
-      using IterableDigraphComponent<Base>::next;
-
-      /// \brief Return the first edge.
-      ///
-      /// This function gives back the first edge in the iteration order.
+      using IterableDigraphComponent<_Base>::first;
+      using IterableDigraphComponent<_Base>::next;
+
+      /// \brief Gives back the first edge in the iterating
+      /// order.
+      ///
+      /// Gives back the first edge in the iterating order.
+      ///
       void first(Edge&) const {}
 
-      /// \brief Return the next edge.
-      ///
-      /// This function gives back the next edge in the iteration order.
+      /// \brief Gives back the next edge in the iterating
+      /// order.
+      ///
+      /// Gives back the next edge in the iterating order.
+      ///
       void next(Edge&) const {}
 
-      /// \brief Return the first edge incident to the given node.
-      ///
-      /// This function gives back the first edge incident to the given
-      /// node. The bool parameter gives back the direction for which the
-      /// source node of the directed arc representing the edge is the
+
+      /// \brief Gives back the first of the edges from the
       /// given node.
+      ///
+      /// Gives back the first of the edges from the given
+      /// node. The bool parameter gives back that direction which
+      /// gives a good direction of the edge so the source of the
+      /// directed arc is the given node.
       void firstInc(Edge&, bool&, const Node&) const {}
 
@@ -814,39 +804,38 @@
       /// given node.
       ///
-      /// This function gives back the next edge incident to the given
-      /// node. The bool parameter should be used as \c firstInc() use it.
+      /// Gives back the next of the edges from the given
+      /// node. The bool parameter should be used as the \c firstInc()
+      /// use it.
       void nextInc(Edge&, bool&) const {}
 
-      using IterableDigraphComponent<Base>::baseNode;
-      using IterableDigraphComponent<Base>::runningNode;
+      using IterableDigraphComponent<_Base>::baseNode;
+      using IterableDigraphComponent<_Base>::runningNode;
 
       /// @}
 
-      /// \name Class Based Iteration
-      ///
-      /// This interface provides iterator classes for edges.
+      /// \name Class based iteration
+      ///
+      /// This interface provides functions for iteration on graph items
       ///
       /// @{
 
-      /// \brief This iterator goes through each edge.
-      ///
-      /// This iterator goes through each edge.
+      /// \brief This iterator goes through each node.
+      ///
+      /// This iterator goes through each node.
       typedef GraphItemIt<Graph, Edge> EdgeIt;
-
-      /// \brief This iterator goes trough the incident edges of a
+      /// \brief This iterator goes trough the incident arcs of a
       /// node.
       ///
-      /// This iterator goes trough the incident edges of a certain
+      /// This iterator goes trough the incident arcs of a certain
       /// node of a graph.
-      typedef GraphIncIt<Graph, Edge, Node, 'e'> IncEdgeIt;
-
+      typedef GraphIncIt<Graph, Edge, Node, 'u'> IncEdgeIt;
       /// \brief The base node of the iterator.
       ///
-      /// This function gives back the base node of the iterator.
+      /// Gives back the base node of the iterator.
       Node baseNode(const IncEdgeIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// This function gives back the running node of the iterator.
+      /// Gives back the running node of the iterator.
       Node runningNode(const IncEdgeIt&) const { return INVALID; }
 
@@ -877,52 +866,52 @@
               typename _Graph::EdgeIt >();
             checkConcept<GraphIncIt<_Graph, typename _Graph::Edge,
-              typename _Graph::Node, 'e'>, typename _Graph::IncEdgeIt>();
+              typename _Graph::Node, 'u'>, typename _Graph::IncEdgeIt>();
 
             typename _Graph::Node n;
-            const typename _Graph::IncEdgeIt ieit(INVALID);
-            n = graph.baseNode(ieit);
-            n = graph.runningNode(ieit);
+            typename _Graph::IncEdgeIt ueit(INVALID);
+            n = graph.baseNode(ueit);
+            n = graph.runningNode(ueit);
           }
         }
 
         const _Graph& graph;
-      };
-    };
-
-    /// \brief Skeleton class for alterable directed graphs.
-    ///
-    /// This class describes the interface of alterable directed
-    /// graphs. It extends \ref BaseDigraphComponent with the alteration
-    /// notifier interface. It implements
+
+      };
+    };
+
+    /// \brief An empty alteration notifier digraph class.
+    ///
+    /// This class provides beside the core digraph features alteration
+    /// notifier interface for the digraph structure.  This implements
     /// an observer-notifier pattern for each digraph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the digraph all the observers will be
+    /// alteration occured in the digraph all the observers will
     /// notified about it.
-    template <typename BAS = BaseDigraphComponent>
-    class AlterableDigraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
+    template <typename _Base = BaseDigraphComponent>
+    class AlterableDigraphComponent : public _Base {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
 
 
-      /// Node alteration notifier class.
+      /// The node observer registry.
       typedef AlterationNotifier<AlterableDigraphComponent, Node>
       NodeNotifier;
-      /// Arc alteration notifier class.
+      /// The arc observer registry.
       typedef AlterationNotifier<AlterableDigraphComponent, Arc>
       ArcNotifier;
 
-      /// \brief Return the node alteration notifier.
-      ///
-      /// This function gives back the node alteration notifier.
+      /// \brief Gives back the node alteration notifier.
+      ///
+      /// Gives back the node alteration notifier.
       NodeNotifier& notifier(Node) const {
-         return NodeNotifier();
+        return NodeNotifier();
       }
 
-      /// \brief Return the arc alteration notifier.
-      ///
-      /// This function gives back the arc alteration notifier.
+      /// \brief Gives back the arc alteration notifier.
+      ///
+      /// Gives back the arc alteration notifier.
       ArcNotifier& notifier(Arc) const {
         return ArcNotifier();
@@ -944,31 +933,32 @@
 
         const _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for alterable undirected graphs.
-    ///
-    /// This class describes the interface of alterable undirected
-    /// graphs. It extends \ref AlterableDigraphComponent with the alteration
-    /// notifier interface of undirected graphs. It implements
-    /// an observer-notifier pattern for the edges. More
+
+      };
+
+    };
+
+    /// \brief An empty alteration notifier undirected graph class.
+    ///
+    /// This class provides beside the core graph features alteration
+    /// notifier interface for the graph structure.  This implements
+    /// an observer-notifier pattern for each graph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the graph all the observers will be
+    /// alteration occured in the graph all the observers will
     /// notified about it.
-    template <typename BAS = BaseGraphComponent>
-    class AlterableGraphComponent : public AlterableDigraphComponent<BAS> {
-    public:
-
-      typedef BAS Base;
+    template <typename _Base = BaseGraphComponent>
+    class AlterableGraphComponent : public AlterableDigraphComponent<_Base> {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Edge Edge;
 
 
-      /// Edge alteration notifier class.
+      /// The arc observer registry.
       typedef AlterationNotifier<AlterableGraphComponent, Edge>
       EdgeNotifier;
 
-      /// \brief Return the edge alteration notifier.
-      ///
-      /// This function gives back the edge alteration notifier.
+      /// \brief Gives back the arc alteration notifier.
+      ///
+      /// Gives back the arc alteration notifier.
       EdgeNotifier& notifier(Edge) const {
         return EdgeNotifier();
@@ -978,5 +968,5 @@
       struct Constraints {
         void constraints() {
-          checkConcept<AlterableDigraphComponent<Base>, _Graph>();
+          checkConcept<AlterableGraphComponent<Base>, _Graph>();
           typename _Graph::EdgeNotifier& uen
             = graph.notifier(typename _Graph::Edge());
@@ -985,39 +975,35 @@
 
         const _Graph& graph;
-      };
-    };
-
-    /// \brief Concept class for standard graph maps.
-    ///
-    /// This class describes the concept of standard graph maps, i.e.
-    /// the \c NodeMap, \c ArcMap and \c EdgeMap subtypes of digraph and
-    /// graph types, which can be used for associating data to graph items.
-    /// The standard graph maps must conform to the ReferenceMap concept.
-    template <typename GR, typename K, typename V>
-    class GraphMap : public ReferenceMap<K, V, V&, const V&> {
-      typedef ReferenceMap<K, V, V&, const V&> Parent;
-
-    public:
-
+
+      };
+
+    };
+
+    /// \brief Class describing the concept of graph maps
+    ///
+    /// This class describes the common interface of the graph maps
+    /// (NodeMap, ArcMap), that is maps that can be used to
+    /// associate data to graph descriptors (nodes or arcs).
+    template <typename _Graph, typename _Item, typename _Value>
+    class GraphMap : public ReadWriteMap<_Item, _Value> {
+    public:
+
+      typedef ReadWriteMap<_Item, _Value> Parent;
+
+      /// The graph type of the map.
+      typedef _Graph Graph;
       /// The key type of the map.
-      typedef K Key;
+      typedef _Item Key;
       /// The value type of the map.
-      typedef V Value;
-      /// The reference type of the map.
-      typedef Value& Reference;
-      /// The const reference type of the map.
-      typedef const Value& ConstReference;
-
-      // The reference map tag.
-      typedef True ReferenceMapTag;
+      typedef _Value Value;
 
       /// \brief Construct a new map.
       ///
       /// Construct a new map for the graph.
-      explicit GraphMap(const GR&) {}
+      explicit GraphMap(const Graph&) {}
       /// \brief Construct a new map with default value.
       ///
-      /// Construct a new map for the graph and initalize the values.
-      GraphMap(const GR&, const Value&) {}
+      /// Construct a new map for the graph and initalise the values.
+      GraphMap(const Graph&, const Value&) {}
 
     private:
@@ -1027,7 +1013,7 @@
       GraphMap(const GraphMap&) : Parent() {}
 
-      /// \brief Assignment operator.
-      ///
-      /// Assignment operator. It does not mofify the underlying graph,
+      /// \brief Assign operator.
+      ///
+      /// Assign operator. It does not mofify the underlying graph,
       /// it just iterates on the current item set and set the  map
       /// with the value returned by the assigned map.
@@ -1042,23 +1028,22 @@
       struct Constraints {
         void constraints() {
-          checkConcept
-            <ReferenceMap<Key, Value, Value&, const Value&>, _Map>();
-          _Map m1(g);
-          _Map m2(g,t);
-
-          // Copy constructor
-          // _Map m3(m);
-
-          // Assignment operator
+          checkConcept<ReadWriteMap<Key, Value>, _Map >();
+          // Construction with a graph parameter
+          _Map a(g);
+          // Constructor with a graph and a default value parameter
+          _Map a2(g,t);
+          // Copy constructor.
+          // _Map b(c);
+
           // ReadMap<Key, Value> cmap;
-          // m3 = cmap;
-
-          ignore_unused_variable_warning(m1);
-          ignore_unused_variable_warning(m2);
-          // ignore_unused_variable_warning(m3);
-        }
-
-        const _Map &m;
-        const GR &g;
+          // b = cmap;
+
+          ignore_unused_variable_warning(a);
+          ignore_unused_variable_warning(a2);
+          // ignore_unused_variable_warning(b);
+        }
+
+        const _Map &c;
+        const Graph &g;
         const typename GraphMap::Value &t;
       };
@@ -1066,15 +1051,14 @@
     };
 
-    /// \brief Skeleton class for mappable directed graphs.
-    ///
-    /// This class describes the interface of mappable directed graphs.
-    /// It extends \ref BaseDigraphComponent with the standard digraph
-    /// map classes, namely \c NodeMap and \c ArcMap.
+    /// \brief An empty mappable digraph class.
+    ///
+    /// This class provides beside the core digraph features
+    /// map interface for the digraph structure.
     /// This concept is part of the Digraph concept.
-    template <typename BAS = BaseDigraphComponent>
-    class MappableDigraphComponent : public BAS  {
-    public:
-
-      typedef BAS Base;
+    template <typename _Base = BaseDigraphComponent>
+    class MappableDigraphComponent : public _Base  {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -1082,13 +1066,13 @@
       typedef MappableDigraphComponent Digraph;
 
-      /// \brief Standard graph map for the nodes.
-      ///
-      /// Standard graph map for the nodes.
-      /// It conforms to the ReferenceMap concept.
-      template <typename V>
-      class NodeMap : public GraphMap<MappableDigraphComponent, Node, V> {
-        typedef GraphMap<MappableDigraphComponent, Node, V> Parent;
-
+      /// \brief ReadWrite map of the nodes.
+      ///
+      /// ReadWrite map of the nodes.
+      ///
+      template <typename _Value>
+      class NodeMap : public GraphMap<Digraph, Node, _Value> {
       public:
+        typedef GraphMap<MappableDigraphComponent, Node, _Value> Parent;
+
         /// \brief Construct a new map.
         ///
@@ -1099,6 +1083,6 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalize the values.
-        NodeMap(const MappableDigraphComponent& digraph, const V& value)
+        /// Construct a new map for the digraph and initalise the values.
+        NodeMap(const MappableDigraphComponent& digraph, const _Value& value)
           : Parent(digraph, value) {}
 
@@ -1109,10 +1093,10 @@
         NodeMap(const NodeMap& nm) : Parent(nm) {}
 
-        /// \brief Assignment operator.
-        ///
-        /// Assignment operator.
+        /// \brief Assign operator.
+        ///
+        /// Assign operator.
         template <typename CMap>
         NodeMap& operator=(const CMap&) {
-          checkConcept<ReadMap<Node, V>, CMap>();
+          checkConcept<ReadMap<Node, _Value>, CMap>();
           return *this;
         }
@@ -1120,13 +1104,13 @@
       };
 
-      /// \brief Standard graph map for the arcs.
-      ///
-      /// Standard graph map for the arcs.
-      /// It conforms to the ReferenceMap concept.
-      template <typename V>
-      class ArcMap : public GraphMap<MappableDigraphComponent, Arc, V> {
-        typedef GraphMap<MappableDigraphComponent, Arc, V> Parent;
-
+      /// \brief ReadWrite map of the arcs.
+      ///
+      /// ReadWrite map of the arcs.
+      ///
+      template <typename _Value>
+      class ArcMap : public GraphMap<Digraph, Arc, _Value> {
       public:
+        typedef GraphMap<MappableDigraphComponent, Arc, _Value> Parent;
+
         /// \brief Construct a new map.
         ///
@@ -1137,6 +1121,6 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalize the values.
-        ArcMap(const MappableDigraphComponent& digraph, const V& value)
+        /// Construct a new map for the digraph and initalise the values.
+        ArcMap(const MappableDigraphComponent& digraph, const _Value& value)
           : Parent(digraph, value) {}
 
@@ -1147,10 +1131,10 @@
         ArcMap(const ArcMap& nm) : Parent(nm) {}
 
-        /// \brief Assignment operator.
-        ///
-        /// Assignment operator.
+        /// \brief Assign operator.
+        ///
+        /// Assign operator.
         template <typename CMap>
         ArcMap& operator=(const CMap&) {
-          checkConcept<ReadMap<Arc, V>, CMap>();
+          checkConcept<ReadMap<Arc, _Value>, CMap>();
           return *this;
         }
@@ -1199,32 +1183,31 @@
         }
 
-        const _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for mappable undirected graphs.
-    ///
-    /// This class describes the interface of mappable undirected graphs.
-    /// It extends \ref MappableDigraphComponent with the standard graph
-    /// map class for edges (\c EdgeMap).
+        _Digraph& digraph;
+      };
+    };
+
+    /// \brief An empty mappable base bipartite graph class.
+    ///
+    /// This class provides beside the core graph features
+    /// map interface for the graph structure.
     /// This concept is part of the Graph concept.
-    template <typename BAS = BaseGraphComponent>
-    class MappableGraphComponent : public MappableDigraphComponent<BAS>  {
-    public:
-
-      typedef BAS Base;
+    template <typename _Base = BaseGraphComponent>
+    class MappableGraphComponent : public MappableDigraphComponent<_Base>  {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Edge Edge;
 
       typedef MappableGraphComponent Graph;
 
-      /// \brief Standard graph map for the edges.
-      ///
-      /// Standard graph map for the edges.
-      /// It conforms to the ReferenceMap concept.
-      template <typename V>
-      class EdgeMap : public GraphMap<MappableGraphComponent, Edge, V> {
-        typedef GraphMap<MappableGraphComponent, Edge, V> Parent;
-
+      /// \brief ReadWrite map of the edges.
+      ///
+      /// ReadWrite map of the edges.
+      ///
+      template <typename _Value>
+      class EdgeMap : public GraphMap<Graph, Edge, _Value> {
       public:
+        typedef GraphMap<MappableGraphComponent, Edge, _Value> Parent;
+
         /// \brief Construct a new map.
         ///
@@ -1235,6 +1218,6 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the graph and initalize the values.
-        EdgeMap(const MappableGraphComponent& graph, const V& value)
+        /// Construct a new map for the graph and initalise the values.
+        EdgeMap(const MappableGraphComponent& graph, const _Value& value)
           : Parent(graph, value) {}
 
@@ -1245,10 +1228,10 @@
         EdgeMap(const EdgeMap& nm) : Parent(nm) {}
 
-        /// \brief Assignment operator.
-        ///
-        /// Assignment operator.
+        /// \brief Assign operator.
+        ///
+        /// Assign operator.
         template <typename CMap>
         EdgeMap& operator=(const CMap&) {
-          checkConcept<ReadMap<Edge, V>, CMap>();
+          checkConcept<ReadMap<Edge, _Value>, CMap>();
           return *this;
         }
@@ -1267,5 +1250,5 @@
 
         void constraints() {
-          checkConcept<MappableDigraphComponent<Base>, _Graph>();
+          checkConcept<MappableGraphComponent<Base>, _Graph>();
 
           { // int map test
@@ -1284,33 +1267,33 @@
         }
 
-        const _Graph& graph;
-      };
-    };
-
-    /// \brief Skeleton class for extendable directed graphs.
-    ///
-    /// This class describes the interface of extendable directed graphs.
-    /// It extends \ref BaseDigraphComponent with functions for adding
-    /// nodes and arcs to the digraph.
-    /// This concept requires \ref AlterableDigraphComponent.
-    template <typename BAS = BaseDigraphComponent>
-    class ExtendableDigraphComponent : public BAS {
-    public:
-      typedef BAS Base;
-
-      typedef typename Base::Node Node;
-      typedef typename Base::Arc Arc;
-
-      /// \brief Add a new node to the digraph.
-      ///
-      /// This function adds a new node to the digraph.
+        _Graph& graph;
+      };
+    };
+
+    /// \brief An empty extendable digraph class.
+    ///
+    /// This class provides beside the core digraph features digraph
+    /// extendable interface for the digraph structure.  The main
+    /// difference between the base and this interface is that the
+    /// digraph alterations should handled already on this level.
+    template <typename _Base = BaseDigraphComponent>
+    class ExtendableDigraphComponent : public _Base {
+    public:
+      typedef _Base Base;
+
+      typedef typename _Base::Node Node;
+      typedef typename _Base::Arc Arc;
+
+      /// \brief Adds a new node to the digraph.
+      ///
+      /// Adds a new node to the digraph.
+      ///
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Add a new arc connecting the given two nodes.
-      ///
-      /// This function adds a new arc connecting the given two nodes
-      /// of the digraph.
+      /// \brief Adds a new arc connects the given two nodes.
+      ///
+      /// Adds a new arc connects the the given two nodes.
       Arc addArc(const Node&, const Node&) {
         return INVALID;
@@ -1332,30 +1315,31 @@
     };
 
-    /// \brief Skeleton class for extendable undirected graphs.
-    ///
-    /// This class describes the interface of extendable undirected graphs.
-    /// It extends \ref BaseGraphComponent with functions for adding
-    /// nodes and edges to the graph.
-    /// This concept requires \ref AlterableGraphComponent.
-    template <typename BAS = BaseGraphComponent>
-    class ExtendableGraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
-      typedef typename Base::Node Node;
-      typedef typename Base::Edge Edge;
-
-      /// \brief Add a new node to the digraph.
-      ///
-      /// This function adds a new node to the digraph.
+    /// \brief An empty extendable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core undircted graph extend interface for the graph structure.
+    /// The main difference between the base and this interface is
+    /// that the graph alterations should handled already on this
+    /// level.
+    template <typename _Base = BaseGraphComponent>
+    class ExtendableGraphComponent : public _Base {
+    public:
+
+      typedef _Base Base;
+      typedef typename _Base::Node Node;
+      typedef typename _Base::Edge Edge;
+
+      /// \brief Adds a new node to the graph.
+      ///
+      /// Adds a new node to the graph.
+      ///
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Add a new edge connecting the given two nodes.
-      ///
-      /// This function adds a new edge connecting the given two nodes
-      /// of the graph.
-      Edge addEdge(const Node&, const Node&) {
+      /// \brief Adds a new arc connects the given two nodes.
+      ///
+      /// Adds a new arc connects the the given two nodes.
+      Edge addArc(const Node&, const Node&) {
         return INVALID;
       }
